import pygtk
pygtk.require('2.0')

import urllib

import gtk
import gtk.gdk
import gobject
import pango

import gio

class MedialistTreeview (gtk.Treeview):
    __init__ (self):
        store = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING, 
                               gobject.TYPE_STRING, gobject.TYPE_UINT, gobject.TYPE_INT)
        store.connect ("row-deleted", self.rowDeleted, None)
        store.connect ("row-inserted", self.rowInserted, None)

#        store.set_sort_func (4, self.sortMediaTreeviewModelCb)
#        store.set_default_sort_func (self.sortMediaTreeviewModelCb)
#        store.set_sort_column_id (-1, gtk.SORT_ASCENDING)

        gtk.TreeView (store)

        treeselection = self..get_selection ()
        treeselection.set_mode (gtk.SELECTION_MULTIPLE)
        treeselection.connect ("changed", self.selectionChangedCb, None)

        renderer = gtk.CellRendererText ()
        column = gtk.TreeViewColumn ('Artist - Title')
        column.set_resizable (True)
        self.append_column (column)
        column.pack_start (renderer, True)
        column.set_attributes (renderer, markup=0)

        renderer = gtk.CellRendererText ()
        column = gtk.TreeViewColumn('Lenght')
        column.set_resizable (True)
        self.append_column (column)
        column.pack_start (renderer, False)
        column.set_attributes (renderer, markup=1)

        self.set_headers_visible (True)

        # medialists callbacks to interesting signals
        self.connect ("row-activated", self.mediaActivatedCb)
        self.connect ("button-release-event", self.mediaSelectedCb)
        self.connect ("button-press-event", self.buttonPressEventCb)
        self.connect ("popup-menu", self.popupMenuHandlerCb)

        dnd_list = [('treeview-row', gtk.TARGET_SAME_WIDGET, 0),
                    ('text/uri-list', 0, 1)]

        self.enable_model_drag_source (gtk.gdk.BUTTON1_MASK,
                                                          dnd_list,
                                                          gtk.gdk.ACTION_DEFAULT|gtk.gdk.ACTION_COPY)
        self.enable_model_drag_dest (dnd_list, gtk.gdk.ACTION_DEFAULT)

        self.connect ("drag-data-get", self.dragDataGetCb)
        self.connect ("drag-data-received", self.dragDataReceivedCb)

